/*
 *  emul.c -- ե顼Υե򤹤
 *
 *  revision history
 *      0.0: Jun.  8, 1996 by Dai ISHIJIMA (bsdfiler.c)
 *      0.1: Jul. 27, 1996
 *      0.2: Aug. 10, 1996
 *	0.3: Sep. 27, 1996
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>

#ifndef SEEK_SET	/* NEWS-OS, SunOS */
#include <unistd.h>
#endif

#include "bsdfiler.h"

#define FILEMODE 0777   /* եΥѡߥå */

static unsigned char sbuf[MAXPACKET];
static unsigned char rbuf[MAXPACKET];
static int rlen, slen;
static int finish;
static int cnt;
static int lastcnt;      /* ҤȤĤޤΥѥåȤΥ */
static long lastfilpos;
static FILE *fp = NULL;
static char curdir[MAXLINE];
static char currentfile[MAXLINE];
static int depth = -1;
static char filnams[MAXDEPTH][MAXDIRENT * FILNAMSIZ];
static char *entries[MAXDEPTH][MAXDIRENT + 1];
static char **dirlst[MAXDEPTH];


/*
 * ³Ȳ
 */
/* ³ */
lxconnect()
{
    slen = clrparm(sbuf, slen, 2);
    strcpy(curdir, "./");
    depth = -1;
}


/* ³ */
discon()
{
    slen = clrparm(sbuf, slen, 6);
    finish = YES;
}


/*
 * ɥ饤֡ǥ쥯ȥ
 */
/* ȥɥ饤ѹ */
logdisk()
{
    /* curdrv = rbuf[4]; */          /* UNIXǤǤϲ⤷ʤ */
    slen = clrparm(sbuf, slen, 6);   /* ˥ɥ饤֤ C: */
    depth = -1;
}


/* Ѳǽɥ饤 */
availdrv()
{
    slen = clrparm(sbuf, slen, 4);
    slen = setshort(sbuf, slen, 2);
    slen = setbyte(sbuf, slen, 'C'); /* Ȥɥ饤֤ C: Τ */
    slen = clrparm(sbuf, slen, 5);
}


/* ȥǥ쥯ȥ */
changedir()
{
    int len;
    char path[MAXLINE];
    
    len = getmesg(rbuf, 4, path);
    slen = clrparm(sbuf, slen, 6);
    if (movdir(curdir, path) == NO) {
	sbuf[6] = CANTMOVEDIR;
    }
}


/* ȥǥ쥯ȥ */
lxgetcwd()
{
    char *s;

    s = dospath(curdir);
    if ((s[strlen(s) - 1] == DOSPATHSEP) && (strlen(s) > 3)) {
	s[strlen(s) - 1] = EOS; /* 롼ȥǥ쥯ȥʳʤ */
    }                           /* ѥκǸ '\' Ȥ */
    slen = clrparm(sbuf, slen, 4);
    slen = setmesg(sbuf, slen, strlen(s), s);
    slen = clrparm(sbuf, slen, 4);
}


/* ǥ쥯ȥ */
lxmkdir()
{
    int len;
    char path[MAXLINE];

    len = getmesg(rbuf, 4, path);
    mkdir(serverpath(curdir, path), FILEMODE);
    slen = clrparm(sbuf, slen, 6);
}


/*
 * ǥ쥯ȥꥹȴϢ
 */
/* ǥ쥯ȥ긡磻ɥ */
setwild()
{
    int len;
    char wildcard[MAXLINE];

    ++depth;
    if (depth < 0) {
	depth = 0;
    }
    else if (depth >= MAXDEPTH) {
	depth = MAXDEPTH - 1;
    }
    len = getmesg(rbuf, 4, wildcard);
    slen = clrparm(sbuf, slen, 6);
    dirlst[depth] = searchdir(wildcard, entries[depth], filnams[depth]);
    /* Υ磻ɥɤȤäƸ */
}


/* ǥ쥯ȥꥨȥ */
getdirent()
{
    lxdirent *entry;
    
    slen = clrparm(sbuf, slen, 4);
    if (*dirlst[depth] != NULL) {
	entry = direntry(*dirlst[depth]);
	slen = setshort(sbuf, slen, 0x16);
	slen = setbyte(sbuf, slen, entry->type);
	slen = setlong(sbuf, slen, entry->timestamp);
	slen = setlong(sbuf, slen, entry->size);
	slen = setparm(sbuf, slen, FILNAMSIZ, entry->name);
	slen = clrparm(sbuf, slen, 4);
	sbuf[slen - 4] = 1; /* ޤ³ */
    }
    else {
	/* ٤ƤΥȥΤ... */
	--dirlst[depth];
	entry = direntry(*dirlst[depth]);
	slen = setshort(sbuf, slen, 0x16);
	slen = setbyte(sbuf, slen, entry->type);
	slen = setlong(sbuf, slen, entry->timestamp);
	slen = setlong(sbuf, slen, entry->size);
	slen = setparm(sbuf, slen, FILNAMSIZ, entry->name);
	slen = clrparm(sbuf, slen, 4);
    }
    ++dirlst[depth];
}


/* ǥ */
lxdfree()
{
    slen = clrparm(sbuf, slen, 4);
    slen = setmesg(sbuf, slen, LABELSIZ, VOLUMELABEL);
    slen = setlong(sbuf, slen, diskfree());
}


/* ǥ쥯ȥ꤫ɤĴ٤ */
getfiltype()
{
    int len;
    char path[MAXLINE];

    len = getmesg(rbuf, 4, path);
    slen = clrparm(sbuf, slen, 6);
    if (filetype(serverpath(curdir, path)) == ISDIR) {
	sbuf[slen - 2] = ISDIR;
    }
}


/*
 * եž
 */
/* ե򳫤 (饤->) */
writeopen()
{
    int len;
    char path[MAXLINE];

    len = getmesg(rbuf, 4, path);
    if (fp != NULL) {
	fclose(fp);
    }
    strcpy(currentfile, serverpath(curdir, path));
    fp = efopen(currentfile, "w");
}


/* ե񤭹 (饤->) */
lxfwrite()
{
    int len;
    char transbuf[DATBLKSIZ];

    len = getmesg(rbuf, 6, transbuf);
    fwrite(transbuf, 1, len, fp);
    slen = clrparm(sbuf, slen, 4);
    setshort(sbuf, slen, len);
}


/* եΥॹ */
setstamp()
{
    long stamp;
    
    stamp = getlong(rbuf, 6);
    slen = clrparm(sbuf, slen, 6);
    if (fp != NULL) {
	fclose(fp);
	fp = NULL;
        /* setmtime(currentfile, stamp); */ /*  :-) */
    }
}


/* եĤ */
lxfclose()
{
    slen = clrparm(sbuf, slen, 6);
    if (fp != NULL) {
	fclose(fp);
	fp = NULL;
    }
}


/* ե򳫤 (->饤) */
readopen()
{
    int len;
    char path[MAXLINE];

    len = getmesg(rbuf, 4, path);
    if (fp != NULL) {
	fclose(fp);
    }
    fp = efopen(serverpath(curdir, path), "r");
    lastfilpos = 0;
    slen = clrparm(sbuf, slen, 6);
}


/* եžλ (?) */
transrdy()
{
    slen = clrparm(sbuf, slen, 6);
    --depth;
    if (depth < 0) {
	depth = 0;
    }
}


/* եɤ߹ (->饤) */
lxfread()
{
    int len;
    char transbuf[DATBLKSIZ];

    len = getshort(rbuf, 6);
    if (cnt == lastcnt) {	/* ȥ饤 */
	fprintf(stderr, "retry sending packet (%02x)\n", cnt);
	fseek(fp, lastfilpos, SEEK_SET);
    }
    lastfilpos = ftell(fp);
    len = fread(transbuf, 1, len, fp);
    slen = clrparm(sbuf, slen, 4);
    slen = setmesg(sbuf, slen, len, transbuf);
}


/* եΥॹ */
lxgetstamp()
{
    slen = clrparm(sbuf, slen, 4);
    slen = setlong(sbuf, slen, tmstamp(currentfile));
}


/* ֤˥ */
lxfseek()
{
    int whence;
    long offset;

    whence = getshort(rbuf, 6);
    offset = getlong(rbuf, 8);
    fseek(fp, offset, whence);
    slen = clrparm(sbuf, slen, 6);
}


/* եݥ */
lxftell()
{
    slen = clrparm(sbuf, slen, 4);
    slen = setlong(sbuf, slen, ftell(fp));
}


/*
 * Ƽե
 */
/* ե̾ѹ */
lxrename()
{
    int olen, nlen;
    char opath[MAXLINE], npath[MAXLINE];

    olen = getmesg(rbuf, 4, opath);
    nlen = getmesg(rbuf, 4 + olen + 2 + 2, npath);
    strcpy(opath, serverpath(curdir, opath));
    strcpy(npath, serverpath(curdir, npath));
    if (rename(opath, npath) == -1) {
	fprintf(stderr, "can't rename %s to %s\n", opath, npath);
    }
    slen = clrparm(sbuf, slen, 6);
}


/* եκ */
lxdelfile()
{
    int olen;
    char opath[MAXLINE], npath[MAXLINE];

    olen = getmesg(rbuf, 4, opath);
    strcpy(opath, serverpath(curdir, opath));
    strcpy(npath, opath);
    strcat(npath, ".BAK");     /* ¤ϥ饤Ȥ鸫ʤ̾ѹ */
    if (rename(opath, npath) == -1) {
	fprintf(stderr, "can't rename %s to %s\n", opath, npath);
    }
    slen = clrparm(sbuf, slen, 6);
}


typedef int (*op)();

typedef struct {
    int code;
    op  action;
} commandlist;

/* ޥɤȴؿбɽ */
static commandlist command[] = {
    CONNECT,	lxconnect,
    DISCON,	discon,
    LOGDSK,	logdisk,
    AVAILDRV,	availdrv,
    CHDIR,	changedir,
    GETCWD,	lxgetcwd,
    MKDIR,	lxmkdir,
    WILDCARD,	setwild,
    GETDIRENT,	getdirent,
    GETDFREE,	lxdfree,
    GETFTYPE,	getfiltype,
    WRITEOPEN,	writeopen,
    FWRITE,	lxfwrite,
    SETSTAMP,	setstamp,
    FCLOSE,	lxfclose,
    READOPEN,	readopen,
    TRANSRDY,	transrdy,
    FREAD,	lxfread,
    GETSTAMP,	lxgetstamp,
    FSEEK,	lxfseek,
    FTELL,	lxftell,
    RENAME,	lxrename,
    DELFILE,	lxdelfile,
    -1,		NULL,
};


/* Ф "ե" 򤹤 */
int emulserver(int fd)
{
    int i;
    int cmd;

    finish = NO;
    rlen = recvpacket(fd, rbuf);
    cmd = sbuf[0] = rbuf[0];
    cnt = sbuf[1] = rbuf[1];
    if (rlen < 0) {
	fprintf(stderr, "packet #%02x crc error\n", cnt);
	return(finish);
    }
    sbuf[2] = REPLYSOH;
    sbuf[3] = rbuf[3];
    slen = 4;
    for (i = 0; command[i].action != NULL; i++) {
	if (command[i].code == cmd) {
	    break;
	}
    }
    if (command[i].action != NULL) {
	(*command[i].action)();
	lastcnt = cnt;
	sendpacket(fd, slen, sbuf);
    }
    else {
	fprintf(stderr, "Unknown command: 0x%02x\n", cmd);
    }
    return(finish);
}
